/* 
   04/02/2010: da 1 a 31

*/

final int    INIZIALE=  0,  
             GIOCO   =  1,
             FINITO  =  2;            
final int    SHUFFLE =500;  // numero di tentativi per mescolare i pezzi         
final int    nRighe  =  8, 
             nColonne=  4,
             nULTIMA =nRighe*nColonne;
final int    dimR    = 42, 
             dimC    = 42;
final int    baseR   =  18, 
             baseC   =  18;
     
int    stato   = INIZIALE;

int    RIGA[],      
       COLONNA[],
       ultimaR,
       ultimaC;        

PImage SFONDO;
String immagini;
PImage IMMAGINI[];
Blocco BLOCCHI[][];

void setup()
{
    size(204,372);
    
    RIGA    =new int[nRighe];              for(int r=0; r<nRighe;   r++) 
                                                RIGA[r]    =r*dimR+baseR;
    COLONNA =new int[nColonne];            for(int c=0; c<nColonne; c++) 
                                                COLONNA[c] =c*dimC+baseC;
    BLOCCHI    =new Blocco[nRighe][nColonne];

    immagini="serie1";  
    IMMAGINI=new PImage[nRighe*nColonne];   
    for(int i=1; i < nRighe*nColonne; i++)
        IMMAGINI[i]=loadImage(immagini+"/"+i+".gif");     
    SFONDO=loadImage(immagini+"/box.gif");
    
    int r, 
        c;    
    r=0;
    c=0;
    for(int i=1; i<nULTIMA;  i++)
    {
      BLOCCHI[r][c]=new Blocco(r, c, i);
      c++;
      if(c==nColonne)
      {
           r++;
           c=0;
      }                                         
    }                   
    ultimaR=nRighe-1;
    ultimaC=nColonne-1;
    BLOCCHI[ultimaR][ultimaC]=new Blocco(ultimaR, ultimaC, 0);        
    noLoop();
}

void draw()
{
    background(SFONDO);
    for(int r=0; r<nRighe;   r++)
    for(int c=0; c<nColonne; c++)
        BLOCCHI[r][c].draw();
}

void controlla()
{
    int r=0,
        c=0;
    for(int i=1; i<nULTIMA;  i++)
    {
       if(BLOCCHI[r][c].valore != i)  
           return;
       c++;
       if(c==nColonne)
       {
           r++;
           c=0;
       }
   } 
   finisci();
}

void finisci()
{
    stato=FINITO;
    redraw();
    delay(2000);         // rendere più visibile che è finito
    stato=INIZIALE;
    redraw(); 
}

void sposta(int nr, int nc)
{
    println(nr + ", " + nc);
    if
    (  
       nr == ultimaR && nc == ultimaC-1 && nc >= 0       ||
       nr == ultimaR && nc == ultimaC+1 && nc < nColonne ||
       nc == ultimaC && nr == ultimaR-1 && nr >= 0       ||
       nc == ultimaC && nr == ultimaR+1 && nr < nRighe )
    {
       // scambia il valore dei blocchi adiacenti
       //      (nr, nc)
       // e 
       //      (ultimaR, ultimaC)
       int  x   = BLOCCHI[nr     ][nc     ].valore;
       char car = BLOCCHI[nr     ][nc     ].carattere;
                  BLOCCHI[nr     ][nc     ].valore   =0;                  
                  BLOCCHI[nr     ][nc     ].carattere=' ';
                  BLOCCHI[ultimaR][ultimaC].valore   =x;
                  BLOCCHI[ultimaR][ultimaC].carattere=car;
       ultimaR=nr;
       ultimaC=nc;
       redraw();                                  // da sistemare...
       if(stato==GIOCO)
           controlla();
    }
}

void mescola()
{
    for(int i=1; i<=SHUFFLE; i++)                // più veloce???
    {
       switch(int(random(4)))
       {
          case 0: sposta(ultimaR+1, ultimaC  ); break;
          case 1: sposta(ultimaR-1, ultimaC  ); break;
          case 2: sposta(ultimaR  , ultimaC+1); break;
          case 3: sposta(ultimaR  , ultimaC-1); break;
       }
    }
}

void mousePressed()
{
    switch(stato)
    {
        case INIZIALE: mescola();
                       stato=GIOCO;
                       break;
        case GIOCO   : int y=mouseY;  int riga   =(y-baseR)/dimR;   
                       int x=mouseX;  int colonna=(x-baseC)/dimC;                      
                       sposta(riga, colonna);        
                       break;
    }   
}

void keyPressed()
{
    switch(stato)
    {
       case INIZIALE: break;
       case GIOCO:    if(key==CODED)
                      {
                         int tasto=keyCode;
                         switch(tasto)
                         {
                            case UP:    sposta(ultimaR+1, ultimaC  ); break;
                            case DOWN:  sposta(ultimaR-1, ultimaC  ); break;
                            case LEFT:  sposta(ultimaR  , ultimaC+1); break;
                            case RIGHT: sposta(ultimaR  , ultimaC-1); break;
                         }
                      }
                      else
                      {
                         int tasto=key;
                         switch(tasto)
                         {
                         }
                      }
                      break;
    }   
}

class Blocco
{
    int  riga;
    int  colonna; 
    int  valore;
    char carattere;

    Blocco(int r, int c, int x)
    {
      riga=r;
      colonna=c;
      valore=x;
    }
    Blocco(int r, int c, int x, char car)
    {
      riga=r;
      colonna=c;
      valore=x;
      carattere=car;
    }
    
    void draw()
    {
        if(valore != 0)  // ....
            image(IMMAGINI[valore], COLONNA[colonna], RIGA[riga]);
    }
}
